#include "djbio.h"
#include "commands.h"
#include "getln.h"

static stralloc cmd = STRALLOC;
static stralloc verb = STRALLOC;
static stralloc arg = STRALLOC;

int commands(djbio *djbiop, register const struct commands *c)
{
  register unsigned int i;
  unsigned int match;

  for (;;) {
    if (!stralloc_erase(&cmd)) return -1;

    if (getln_max(djbiop, &cmd, &match, '\n', 1024) < 0) return -1;
    if (!match) return (int)cmd.len;

    stralloc_replace(&cmd, '\0', '\n');
    stralloc_trim(&cmd, "\r\n", 2);

    i = stralloc_chr(&cmd, ' ');
    if (!stralloc_copyb(&verb, cmd.s, i)) return -1;
    stralloc_lower(&verb);

    while (i < cmd.len) {
      if (cmd.s[i] != ' ') break;
      i++;
    }
    stralloc_copyb(&arg, cmd.s + i, cmd.len - i);

    for (i = 0; c[i].verb; ++i) {
      if (stralloc_equals(&verb, c[i].verb)) break;
    }
    c[i].action(&arg);
    if (c[i].flush) {
      c[i].flush();
    }
  }
}
