#include <nemo/error.h>
#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/unix.h>

#include "djbio.h"
#include "getln.h"
#include "readclose.h"

static inline int cleanup(int fd)
{
  close(fd);
  return -1;
}

int readlineclose(int fd, register stralloc *out)
{
  unsigned int match;
  djbio io_in;
  char buffer[128];

  if (!stralloc_erase(out)) return cleanup(fd);
  djbio_initread(&io_in, read, fd, buffer, sizeof(buffer));
  if (getln(&io_in, out, &match, '\n') < 0) return cleanup(fd);
  stralloc_trim(out, " \t\r\n", 4);
  if (close(fd) < 0) return -1;
  return 1;
}
