#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <nemo/byte.h>

#include "socket.h"

#include <nemo/uint16.h>

int socket6_bind(int s, const ip6_address *ip, uint16_t port)
{
  struct sockaddr_in6 sa;

  byte_zero(&sa, sizeof(sa));
  sa.sin6_family = AF_INET6;
  uint16_pack_big(port, &sa.sin6_port);
  ip6_pack(ip, &sa.sin6_addr);
  sa.sin6_scope_id = ip->sid;
  return bind(s, (struct sockaddr*)&sa, sizeof sa);
}
