#ifndef NEMO_STRERR_H
#define NEMO_STRERR_H

#include <nemo/macro_noreturn.h>

#ifdef __cplusplus
extern "C" {
#endif

struct strerr
{
  struct strerr *who;
  const char *x;
  const char *y;
  const char *z;
};

extern struct strerr strerr_sys;

void	strerr_sysinit(void);

void	strerr_warn(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6, struct strerr *se);
void	strerr_die(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6, struct strerr *se) __NORETURN__;

void	strerr_warn6(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6, struct strerr *se);
void	strerr_warn5(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, struct strerr *se);
void	strerr_warn4(const char *x1, const char *x2, const char *x3, const char *x4, struct strerr *se);
void	strerr_warn3(const char *x1, const char *x2, const char *x3, struct strerr *se);
void	strerr_warn2(const char *x1, const char *x2, struct strerr *se);
void	strerr_warn1(const char *x1, struct strerr *se);

void	strerr_warn6sys(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6);
void	strerr_warn5sys(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5);
void	strerr_warn4sys(const char *x1, const char *x2, const char *x3, const char *x4);
void	strerr_warn3sys(const char *x1, const char *x2, const char *x3);
void	strerr_warn2sys(const char *x1, const char *x2);
void	strerr_warn1sys(const char *x1);

void	strerr_warn6x(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6);
void	strerr_warn5x(const char *x1, const char *x2, const char *x3, const char *x4, const char *x5);
void	strerr_warn4x(const char *x1, const char *x2, const char *x3, const char *x4);
void	strerr_warn3x(const char *x1, const char *x2, const char *x3);
void	strerr_warn2x(const char *x1, const char *x2);
void	strerr_warn1x(const char *x1);

void	strerr_die6(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6, struct strerr *se) __NORETURN__;
void	strerr_die5(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, struct strerr *se) __NORETURN__;
void	strerr_die4(int e, const char *x1, const char *x2, const char *x3, const char *x4, struct strerr *se) __NORETURN__;
void	strerr_die3(int e, const char *x1, const char *x2, const char *x3, struct strerr *se) __NORETURN__;
void	strerr_die2(int e, const char *x1, const char *x2, struct strerr *se) __NORETURN__;
void	strerr_die1(int e, const char *x1, struct strerr *se) __NORETURN__;

void	strerr_die6sys(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6) __NORETURN__;
void	strerr_die5sys(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5) __NORETURN__;
void	strerr_die4sys(int e, const char *x1, const char *x2, const char *x3, const char *x4) __NORETURN__;
void	strerr_die3sys(int e, const char *x1, const char *x2, const char *x3) __NORETURN__;
void	strerr_die2sys(int e, const char *x1, const char *x2) __NORETURN__;
void	strerr_die1sys(int e, const char *x1) __NORETURN__;

void	strerr_die6x(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5, const char *x6) __NORETURN__;
void	strerr_die5x(int e, const char *x1, const char *x2, const char *x3, const char *x4, const char *x5) __NORETURN__;
void	strerr_die4x(int e, const char *x1, const char *x2, const char *x3, const char *x4) __NORETURN__;
void	strerr_die3x(int e, const char *x1, const char *x2, const char *x3) __NORETURN__;
void	strerr_die2x(int e, const char *x1, const char *x2) __NORETURN__;
void	strerr_die1x(int e, const char *x1) __NORETURN__;

#define STRERR(r,se,a) \
{ se.who = 0; se.x = a; se.y = 0; se.z = 0; return r; }

#define STRERR_SYS(r,se,a) \
{ se.who = &strerr_sys; se.x = a; se.y = 0; se.z = 0; return r; }
#define STRERR_SYS2(r,se,a,b) \
{ se.who = &strerr_sys; se.x = a; se.y = b; se.z = 0; return r; }
#define STRERR_SYS3(r,se,a,b,c) \
{ se.who = &strerr_sys; se.x = a; se.y = b; se.z = c; return r; }

#ifdef __cplusplus
}
#endif

#endif
